// Copyright 2005-2008 Alco Blom
// All rights reserved

var myRecentItemsLength = 25;
var recentLocationArray = new Array();
var yahooArray = new Array();
var outlookArray = new Array();
var addressBookArray = new Array();

function purchaseProducts()
{
	if (preferences.hasAccount.value == 0) {
		var url;
		
		if ( system.platform == "macintosh" )
			url = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=purchase";
		else
			url = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=purchase_win";
			
		url = addCampaign(url, 'order', false);
		
		openURL(url);
		
	} else {
		var url;
		
		if ( system.platform == "macintosh" )
			url = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=buysms";
		else
			url = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=buysms_win";
			
		url = addCampaign(url, 'buysms', true);
		
		openURL(url);
		
	}
}

function gotoHomePage()
{
	if ( system.platform == "macintosh" )
		openURL("http://www.smsmac.com/"); 
	else
		openURL("http://www.smsvista.com/");
}

function gotoHelpPage()
{
	openURL("http://www.smsmac.com/cgi-bin/hb?lang=en&subj=help");
}

function quickStart()
{
	openURL("http://www.smsmac.com/cgi-bin/hb?lang=en&subj=qs_windows");
}

function quickStarteMobile()
{
	openURL("http://www.smsmac.com/cgi-bin/hb?lang=en&subj=qs_emobile");
}

function doPopupMenu() {
	var myPlace = 0;
	var items = new Array();
	
	// add header in menu
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Help...";
	items[myPlace].onSelect = "gotoHelpPage();";
	myPlace++;
	
	items[myPlace] = new MenuItem();
	if (preferences.hasAccount.value == 0)
		items[myPlace].title = "Buy Send SMS...";
	else
		items[myPlace].title = "Buy More SMS...";
	
	items[myPlace].onSelect = "purchaseProducts();";
	myPlace++;

	// further explanations
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Quick Start...";
	items[myPlace].onSelect = "quickStart();";
	myPlace++;

	// further explanations
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Quick Start eMobile...";
	items[myPlace].onSelect = "quickStarteMobile();";
	myPlace++;

	// add a divider
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	if (preferences.recentLocationsPreference.value != "")
	{
		readRecentLocationPref();
		
		// add header in menu
		items[myPlace] = new MenuItem();
		items[myPlace].title = "Recent Mobiles";
		items[myPlace].enabled = 0;
		myPlace++;

		// add recent mobile numbers
		for (item in recentLocationArray)
		{	
			items[myPlace] = new MenuItem();
			
			// add menu title
			var displayName = recentLocationArray[item].displayName;
			if (displayName != "")
				items[myPlace].title = displayName;
			else
				items[myPlace].title = recentLocationArray[item].mobile;

			// check current selection
			if ( recentLocationArray[item].mobile == preferences.to.value && displayName == preferences.name.value)
			{
				items[myPlace].checked = 1;
			}
			
			// add menu callback
			items[myPlace].onSelect = "doContextMenu( " + item + " );";
			
			myPlace++;
		}

		// add a divider
		items[myPlace] = new MenuItem();
		items[myPlace].title = "-";
		myPlace++;
		
		// add 'Edit Recent Mobile...' menu item
		myPlace = editMobileMenuItem(items, myPlace);

		// add 'Remove Recent Mobile...' menu item
		myPlace = removeMobileMenuItem(items, myPlace);

		// add a divider
		items[myPlace] = new MenuItem();
		items[myPlace].title = "-";
		myPlace++;

		// add 'Clear Recent Mobiles' item
		items[myPlace] = new MenuItem();
		items[myPlace].title = "Clear Recent Mobiles";
		items[myPlace].onSelect = "clearRecentMobiles();";
		myPlace++;
	}
	else
	{	
		// startup situation
		items[myPlace] = new MenuItem();
		items[myPlace].title = "No Recent Mobiles";
		items[myPlace].enabled = 0;
		myPlace++;
	}
	
	// add 'Add Mobile...' menu item
	myPlace = addMobileMenuItem(items, myPlace);
	
	// add 'Add eMobile...' menu item
	myPlace = addEMobileMenuItem(items, myPlace);

	// add 'Yahoo! AddressBook...' menu item
	myPlace = addYahooABPart(items, myPlace);

	// add 'Outlook Contacts...' menu item
	if (system.platform == "windows") 
		myPlace = addOutlookPart(items, myPlace);

	// add 'Address Book...' menu item
	if (system.platform == "macintosh")
		myPlace = addAddressBookPart(items, myPlace);

	// add contextual menu to window
	mainWindow.contextMenuItems = items;
}

function addMobileMenuItem(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	items[myPlace] = new MenuItem();
	items[myPlace].title = "Add Mobile...";
	items[myPlace].onSelect = "AddMobile();";
	myPlace++;
	
	return myPlace;
}

function addEMobileMenuItem(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Add eMobile...";
	items[myPlace].onSelect = "AddEMobile();";
	myPlace++;
	
	return myPlace;
}

function editMobileMenuItem(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Edit Recent Mobile...";
	items[myPlace].onSelect = "EditRecentMobile();";
	myPlace++;
	
	return myPlace;
}

function removeMobileMenuItem(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Remove Recent Mobile...";
	items[myPlace].onSelect = "RemoveRecentMobile();";
	myPlace++;
	
	return myPlace;
}

function addYahooABPart(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	// add header in menu
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Yahoo! Address Book";
	items[myPlace].enabled = 0;
	myPlace++;

	myPlace = AddYahooMenuItems(items, myPlace);
	
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	items[myPlace] = new MenuItem();
	items[myPlace].title = "Import Yahoo! Address Book...";
	items[myPlace].onSelect = "ImportYahoo();";
	myPlace++;
	
	return myPlace;
}

function AddYahooMenuItems(items, myPlace) {
	if (preferences.yahooAddressBook.value != "")
	{
		readYahooAddressBook();
		
		// add recent mobile numbers
		for (item in yahooArray)
		{	
			items[myPlace] = new MenuItem();
			
			// add menu title
			if (yahooArray[item].displayName != "")
				items[myPlace].title =  yahooArray[item].displayName;
			else
				items[myPlace].title =  yahooArray[item].mobile;

			// add menu callback
			items[myPlace].onSelect = "doYahooItem( " + item + " );";
	
			// next
			myPlace++;
		}
	}
	
	return myPlace;
}

function addOutlookPart(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	// add header in menu
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Outlook Contacts";
	items[myPlace].enabled = 0;
	myPlace++;

	myPlace = AddOutlookMenuItems(items, myPlace);
	
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	items[myPlace] = new MenuItem();
	items[myPlace].title = "Import Outlook Contacts...";
	items[myPlace].onSelect = "ImportOutlook();";
	myPlace++;

	return myPlace;
}

function AddOutlookMenuItems(items, myPlace) {
	if (preferences.outlookContacts.value != "")
	{
		var i = 0;
		
		readOutlookContacts();
			
		// add outlook mobile numbers
		for (item in outlookArray)
		{				
			items[myPlace] = new MenuItem();
			
			// add menu title
			if (outlookArray[item].displayName != "")
				items[myPlace].title =  outlookArray[item].displayName;
			else
				items[myPlace].title =  outlookArray[item].mobile;
	
			// add menu callback
			items[myPlace].onSelect = "doOutlookItem( " + item + " );";
	
			// next
			myPlace++;
		}
	}
	
	return myPlace;
}

function addAddressBookPart(items, myPlace) {
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	// add header in menu
	items[myPlace] = new MenuItem();
	items[myPlace].title = "Address Book Contacts";
	items[myPlace].enabled = 0;
	myPlace++;

	myPlace = AddAddressBookMenuItems(items, myPlace);
	
	items[myPlace] = new MenuItem();
	items[myPlace].title = "-";
	myPlace++;

	items[myPlace] = new MenuItem();
	items[myPlace].title = "Import Address Book Contacts...";
	items[myPlace].onSelect = "ImportAddressBook();";
	myPlace++;

	return myPlace;
}

function AddAddressBookMenuItems(items, myPlace) {
	if (preferences.addressBookContacts.value != "")
	{
		var i = 0;
		
		readAddressBookContacts();
		
		// add outlook mobile numbers
		for (item in addressBookArray)
		{	
			items[myPlace] = new MenuItem();
			
			// add menu title
			if (addressBookArray[item].displayName != "")
				items[myPlace].title =  addressBookArray[item].displayName;
			else
				items[myPlace].title =  addressBookArray[item].mobile;
	
			// add menu callback
			items[myPlace].onSelect = "doAddressBookItem( " + item + " );";
	
			// next
			myPlace++;
		}
	}
	
	return myPlace;
}

function clearRecentMobiles()
{
	var answer = alert("Are you sure you want to erase all your Recent Mobile numbers?", "Yes", "No");
	if (answer == 1) {

		preferences.recentLocationsPreference.value = '';

		// set current mobile to none
		preferences.to.value = "";
		preferences.name.value = "";

		setTitle("", "");
	
		savePreferences();
	}
}

function doContextMenu(whichItem)
{
	log('doContextMenu');

	// set current mobile to chosen one
	preferences.to.value = recentLocationArray[whichItem].mobile;
	preferences.name.value = recentLocationArray[whichItem].displayName;
	
	// remove chosen one from this position in the recent list
	selectedItem = recentLocationArray.splice(whichItem, 1);

	// get last position
	theCount = Number(recentLocationArray.length);

	// add mobile number to bottom of list
	recentLocationArray[theCount] = new Array();
	recentLocationArray[theCount].mobile = selectedItem[0].mobile;
	recentLocationArray[theCount].displayName = selectedItem[0].displayName;
	
	// store the list
	writeRecentLocationPref();

	// update the widget's appearance
	setTitle(preferences.name.value, preferences.to.value);
}

function doYahooItem(whichItem)
{
	log('doYahooItem');

	var name = yahooArray[whichItem].displayName;
	var mobile = yahooArray[whichItem].mobile;
	
	// strip all formatting
	mobile = mobile.replace(/[^0-9+]/g, "");

	// set current mobile to chosen one
	preferences.to.value = mobile;
	preferences.name.value = name;

	// remove chosen one from this position in the recent list, if it is there
	removeRecentMobile(name, mobile);
	
	// maximum reached: delete the less recent one (number zero)
	if ( recentLocationArray.length == myRecentItemsLength )
		recentLocationArray.splice(0, 1);

	// get last position
	theCount = Number(recentLocationArray.length);

	// add mobile number to bottom of list
	recentLocationArray[theCount] = new Array();
	recentLocationArray[theCount].mobile = mobile;
	recentLocationArray[theCount].displayName = name;

	// store the list
	writeRecentLocationPref();

	// update the widget's appearance
	setTitle(preferences.name.value, preferences.to.value);
}

function doOutlookItem(whichItem)
{
	log('doOutlookItem');

	var name = outlookArray[whichItem].displayName;
	var mobile = outlookArray[whichItem].mobile;

	// strip all formatting
	mobile = mobile.replace(/[^0-9+]/g, "");

	// set current mobile to chosen one
	preferences.to.value = mobile;
	preferences.name.value = name;

	// remove chosen one from this position in the recent list, if it is there
	removeRecentMobile(name, mobile);
	
	// maximum reached: delete the less recent one (number zero)
	if ( recentLocationArray.length == myRecentItemsLength )
		recentLocationArray.splice(0, 1);

	// get last position
	theCount = Number(recentLocationArray.length);

	// add mobile number to bottom of list
	recentLocationArray[theCount] = new Array();
	recentLocationArray[theCount].mobile = mobile;
	recentLocationArray[theCount].displayName = name;

	// store the list
	writeRecentLocationPref();

	// update the widget's appearance
	setTitle(preferences.name.value, preferences.to.value);
}

function doAddressBookItem(whichItem)
{
	log('doAddressBookItem');

	var name = addressBookArray[whichItem].displayName;
	var mobile = addressBookArray[whichItem].mobile;

	// strip all formatting
	mobile = mobile.replace(/[^0-9+]/g, "");

	// set current mobile to chosen one
	preferences.to.value = mobile;
	preferences.name.value = name;

	// remove chosen one from this position in the recent list, if it is there
	removeRecentMobile(name, mobile);
	
	// maximum reached: delete the less recent one (number zero)
	if ( recentLocationArray.length == myRecentItemsLength )
		recentLocationArray.splice(0, 1);

	// get last position
	theCount = Number(recentLocationArray.length);

	// add mobile number to bottom of list
	recentLocationArray[theCount] = new Array();
	recentLocationArray[theCount].mobile = mobile;
	recentLocationArray[theCount].displayName = name;

	// store the list
	writeRecentLocationPref();

	// update the widget's appearance
	setTitle(preferences.name.value, preferences.to.value);
}

function readRecentLocationPref()
{
	myLoadedPrefs = preferences.recentLocationsPreference.value.replace("\'","'");
	
	try {
		recentLocationArray = eval( "new Array(" + myLoadedPrefs + ")" );

		// sort the recipients
		if (recentLocationArray.length > 1) {
			recentLocationArray.sort(callbackFunc);
			print('array sorted');
		}

	} catch(exception) {
		log('unable to read in Recent Mobiles from preferences.');
	}
}

function writeRecentLocationPref()
{
	var prefString = "";
		
	for ( items in recentLocationArray )
	{
		prefString += "{mobile:'" + recentLocationArray[items].mobile.replace("'","\\'");
		prefString += "',displayName:'" + recentLocationArray[items].displayName.replace("'","\\'") + "'}";
		if ( items != ( recentLocationArray.length - 1 ) )
			prefString += ", ";
	}
	
	log("the recent location string is: ");
	log(prefString);
	
	preferences.recentLocationsPreference.value = prefString;
	
	savePreferences();
}

function readYahooAddressBook()
{
	var myLoadedPrefs = preferences.yahooAddressBook.value.replace("\'","'");
	try {
		yahooArray = eval( "new Array(" + myLoadedPrefs + ")" );
		
		// sort recipients
		if (yahooArray.length > 1) {
			yahooArray.sort(callbackFunc);
		}
		
	} catch(exception) {
		yahooArray.length = 0;
		log('unable to read in Yahoo! Addresses from preferences.');
	}
}

function readOutlookContacts()
{
	var myLoadedPrefs = preferences.outlookContacts.value.replace("\'","'");
	try {
		outlookArray = eval( "new Array(" + myLoadedPrefs + ")" );
		
		// sort recipients
		if (outlookArray.length > 1) {
			outlookArray.sort(callbackFunc);
		}
		
	} catch(exception) {
		outlookArray.length = 0;
		log('unable to read in Outlook Contacts from preferences.');
		log(myLoadedPrefs);
	}
}

function readAddressBookContacts()
{
	var myLoadedPrefs = preferences.addressBookContacts.value.replace("\'","'");
	try {
		addressBookArray = eval( "new Array(" + myLoadedPrefs + ")" );
		
		// sort recipients
		if (addressBookArray.length > 1) {
			addressBookArray.sort(callbackFunc);
		}
		
	} catch(exception) {
		addressBookArray.length = 0;
		log('unable to read in Address Book contacts from preferences.');
		log(myLoadedPrefs);
	}
}

function writeYahooAddressBook()
{
	var prefString = "";
	
	for ( items in yahooArray )
	{
		prefString += "{mobile:'" + yahooArray[items].mobile.replace("'","\\'");
		prefString += "',displayName:'" + yahooArray[items].displayName.replace("'","\\'") + "'}";
		if ( items != ( yahooArray.length - 1 ) )
			prefString += ", ";
	}
	
	log("the preferences string is: ");
	log(prefString);
	
	preferences.yahooAddressBook.value = prefString;
	
	savePreferences();
}

function writeOutlookContacts()
{
	var prefString = "";
	
	for ( items in outlookArray )
	{
		prefString += "{mobile:'" + outlookArray[items].mobile.replace("'","\\'");
		prefString += "',displayName:'" + outlookArray[items].displayName.replace("'","\\'") + "'}";
		if ( items != ( outlookArray.length - 1 ) )
			prefString += ", ";
	}
	
	log("the preferences string is: ");
	log(prefString);
	
	preferences.outlookContacts.value = prefString;
	
	savePreferences();
}

function addYahooMobile(displayName, mobile)
{
	log("add to Yahoo! mobiles");

	// strip all formatting
	mobile = mobile.replace(/[^0-9+]/g, "");

	// end of list
	var theCount = Number(yahooArray.length);

	yahooArray[theCount] = new Array();
	yahooArray[theCount].mobile = mobile;
	yahooArray[theCount].displayName = displayName;
		
	log("Yahoo! mobile added");
}

function addOutlookMobile(displayName, mobile)
{
	log("add to Outlook mobiles");

	// strip all formatting
	mobile = mobile.replace(/[^0-9+]/g, "");

	// end of list
	var theCount = Number(outlookArray.length);

	outlookArray[theCount] = new Array();
	outlookArray[theCount].mobile = mobile;
	outlookArray[theCount].displayName = displayName;
		
	log("Outlook mobile added");
}

function editRecentMobileByIndex(index) {
	var updateHeader = false;
	
	log("edit a recent mobile");
	readRecentLocationPref();

	var mobileNumber = recentLocationArray[index].mobile;
	var contactName = recentLocationArray[index].displayName;
	
	if (isEmail(mobileNumber)) {
		EditEMobileWithParam(index, contactName, mobileNumber);
		return;
	}
	
	if (mobileNumber == preferences.to.value) {
		updateHeader = true;
	}
	
	// show window
	formResults	= EditMobileWindow(index, contactName, mobileNumber);	
	if (formResults	!= null) {
		writeRecentLocationPref();
		log("recent mobiles updated");
		
		if (updateHeader) {
			var mobile = formResults[0];
			var displayName = formResults[1];

			// construct mobile number
			preferences.to.value = mobile;
			
			// get display name
			preferences.name.value = displayName;
						
			// save preferences
			savePreferences();

			// update mobile title
			setTitle(displayName, mobile);
		}
	}
}

function removeRecentMobileByIndex(index) {
	log("remove a recent mobile");
	readRecentLocationPref();
	
	recentLocationArray.splice(index, 1);

	writeRecentLocationPref();
	log("recent mobiles removed/updated");
}

function removeRecentMobile(name, mobile)
{
	log("remove a recent mobile");
	readRecentLocationPref();
	
	// the mobile already appears at another location (item) in the popup menu
	for (item in recentLocationArray)
	{
		if (mobile == recentLocationArray[item].mobile && name == recentLocationArray[item].displayName) {
			recentLocationArray.splice(item, 1);
			break;
		}
	}

	writeRecentLocationPref();
	log("recent mobiles removed/updated");
}

function updateRecentMobile(name, mobile, index)
{
	log("update recent mobiles");

	var updtLocation = true;

	readRecentLocationPref();
	
	// the mobile already appears at another location (item) in the popup menu
	for (item in recentLocationArray)
	{
		if (mobile == recentLocationArray[item].mobile && item != index)
			updtLocation = false;
	}

	if (updtLocation) {
		var n = Number(recentLocationArray.length);
		if (index >= 0 && index < n) {
			recentLocationArray[index].mobile = mobile;
			recentLocationArray[index].displayName = name;
			
			writeRecentLocationPref();
			log("recent mobiles updated");
		} else {
			updtLocation = false;
			log("out of bounds");
		}
	}
	
	return updtLocation;
}

function addRecentMobile(displayName, mobile)
{
	log("add to recent mobiles");

	var addLocation = true;
	
	readRecentLocationPref();
	
	for (item in recentLocationArray)
	{
		if ( mobile == recentLocationArray[item].mobile || displayName == recentLocationArray[item].displayName)
			addLocation = false;
	}

	if (addLocation)
	{
		// maximum reached: delete the less recent one (number zero)
		if ( recentLocationArray.length == myRecentItemsLength )
			recentLocationArray.splice(0, 1);

		// end of list
		var theCount = Number(recentLocationArray.length);

		recentLocationArray[theCount] = new Array();
		recentLocationArray[theCount].mobile = mobile;
		recentLocationArray[theCount].displayName = displayName;
		
		writeRecentLocationPref();
		log("recent mobiles added");
	}

	return addLocation;
}

function findMobileIndex(mobile)
{
	var myPlace = 0;
	var found = false;
		
	log('mobile to find is:', mobile);
	readRecentLocationPref();
		
	// find in recent mobile numbers
	for (item in recentLocationArray)
	{	
		if ( recentLocationArray[item].mobile == mobile )
		{
			found = true;
			break;
		}
		
		myPlace++;
	}
	
	if (found)
		return myPlace;
	else
		log("not found");
		
	return -1;
}

function IndexesMobiles() {
  var indexes = new Array();
  
  readRecentLocationPref();
  
  for (var i = 0; i < recentLocationArray.length; i++) {
    indexes[i] = i;
  }
  
  return indexes;
}

function RecentNamesList() {
  var names = new Array();
  
  readRecentLocationPref();
  
  for (var i = 0; i < recentLocationArray.length; i++) {
  	names[i] = recentLocationArray[i].displayName + " (" + recentLocationArray[i].mobile + ")";
  }
  
  return names;
}

function callbackFunc(a, b){

	if (a.displayName == b.displayName) {
		return 0;
	}

	return (a.displayName < b.displayName) ? -1 : 1;
}