// Copyright 2005-2008 Alco Blom
// All rights reserved

var productComputerVersion = "0180";

var textSMS = "";
var status = false;

var update = false;
var buySMS = false;
var expired = false;
var email2SMS = false;
var trialAccount = false;

var queryURL = "";
var productURL = "";
var purchaseURL = "";
var errorMessage = "";

var signatureLen = 0;

var walkerObj = 0;
//var walkerImg = new Image();
//walkerImg.hOffset = -100;
//walkerImg.src = "Resources/letterb.png";

var carriers = [
	{name:'ACS Wireless', gate:"@msg.acsalaska.com"},
	{name:'Alltel', gate:"@message.alltel.com"},
	{name:'AT&T Wireless', gate:"@mmode.com"},
	{name:'Cellular One', gate:"@mobile.celloneusa.com"},
	{name:'Cingular', gate:"@mobile.mycingular.com"},
	{name:'Metro PCS', gate:"@mymetropcs.com"},
	{name:'Nextel', gate:"@messaging.nextel.com"},
	{name:'Qwest', gate:"@qwestmp.com"},
	{name:'Sprint', gate:"@messaging.sprintpcs.com"},
	{name:'T-Mobile', gate:"@tmomail.net"},
	{name:'Unicel', gate:"@utext.com"},
	{name:'US Cellular', gate:"@email.uscc.net"},
	{name:'Verizon Pagers', gate:"@myairmail.com"},
	{name:'Verizon Wireless', gate:"@vtext.com"},
	{name:'Virgin Mobile', gate:"@vmobl.com"},
	{name:'(-', gate:"@"},
	{name:'Bell Mobility Canada', gate:"@txt.bellmobility.ca"},
	{name:'Fido Canada', gate:"@fido.ca"},
	{name:'Rogers Canada', gate:"@pcs.rogers.com"},
	{name:'Telus Canada', gate:"@msg.telus.com"},
	{name:'Virgin Mobile Canada', gate:"@vmobile.ca"},
];

function sendsms()
{
	var unicode = false;
	var callerID = null;
	var delivery = false;
	
	var maxLen = (160 - 7) * 3;
	var maxLenUnicode = (70 - 7) * 3;

	print("system.languages:	"	+	system.languages);

	log("account ID:" + preferences.accountID.value);
	log("PIN code:" + preferences.PIN.value);
	log("to:" + preferences.to.value);
	log("name:" + preferences.name.value);
	log("caller ID:" + preferences.callerID.value);
	log("signature status:" + preferences.addsignature.value);
	log("signature:" + preferences.signature.value);
	log("delivery:" + preferences.delivery.value);
	log("report:" + preferences.reportEmailAddress.value);
	log("replies:" + preferences.replies.value);
	log("alpha ID:" + preferences.alphaID.value);
	log("use alpha ID:" + preferences.usealphaID.value);
	
	log("SMS is:" + text.data);
	
	/*
	var len = text.data.length;
	for(var i = 0;i<len;i++) {
		log(text.data.charAt([i]) + " : " + text.data.charCodeAt([i]));
	}
	*/
	
	log("calling sendsms();");

	// start processing
	if (status) {
		setStatusText2("Please clear the error message first. Use the eraser button (the lower right button).");
		return;
	}
		
	// preferences
	var unicode = false;

	// the SMS
	var txt = text.data;	
	if (txt.length == 0)
	{
		setStatusText("Please enter your SMS text first.");
		return;
	}

	// about the PIN
	var pin = preferences.PIN.value;
	if (pin == null || pin.length != 4 || pin == '0000')
	{
		setStatusText("The account settings are not correct.");
		return;
	}

	// check PIN value
	var aNumber = Number(pin);
	if (isNaN(aNumber))
	{
		setStatusText("The PIN code is not correct.");
		return;
	}
	
	// account ID
	var email = preferences.accountID.value;
	if (email == null || email.length == 0 || !isEmail(email))
	{
		setStatusText("The account settings are not correct.");
		return;
	} else
	{
		email = escape(email);
	}

	// mobile number
	var phonenumber = preferences.to.value;
	if (phonenumber.length <= 5)
	{
		setStatusText("Please define a recipient first.");
		return;
	}
		
	var mobile = phonenumber;
	
	// check configuration for email2SMS
	if (isEmail(phonenumber)) {	
	
		email2SMS = true;
		
		var emailAddress = preferences.emailreply.value;
		if (emailAddress == null || emailAddress == "") {
			setStatusText("Please specify your email address in the \'Reply to Email\' preference.");
			return;
		}
		
	} else {
	
		email2SMS = false;
		
		if (phonenumber.charAt(0) != '+') {
			setStatusText("Mobile numbers must be in international format.");
			return;
		}
	}
	
	// escape just in case
	phonenumber = escape(phonenumber);

	// get signature preference
	var signature = getSignature();		
	if (signature != null) {
		signatureLen = getSignatureLen(signature);
		
		// add signature
		txt = txt + signature;
	} else
		signatureLen = 0;
	
	// check to see if Unicode
	if (isUnicode(txt)) {
		log("this is a Unicode SMS");
		unicode = true;
		maxLen = maxLenUnicode; // 2 SMS allowed when Unicode
	}	

	// calculate the length of the SMS
	if (unicode)
		len = txt.length;
	else
		len = gsmLength(txt);

	// update total just in case
	setTotal(len);

	// the SMS is too long
	if (len > maxLen) {
		// the SMS exceeds 160 or (70-7)*2 characters
		var message = "The SMS exceeds %d characters. Please remove some.";
		message = message.replace(/%d/i, maxLen);

		setStatusText(message);
		return;
	}
	
	txt = txt.substring(0, maxLen);

	// escape special characters
	var sms = escapeSMS(txt);
	log("escaped SMS is:" + sms);
	
	// initial query
	var query;
	if ( system.platform == "macintosh" )
		query = "http://www.smsmac.com/cgi-bin/sms?cmd=sendmsg&prod=KFM" + productComputerVersion;
	else
		query = "http://www.smsmac.com/cgi-bin/sms?cmd=sendmsg&prod=KFW" + productComputerVersion;
		
	// build query
	query = query + "&email=" + email + "&pin=" + pin + "&to=" + phonenumber + "&text=" + sms;
		
	if (email2SMS) {
		
		// add reply email address
		var emailAddress = preferences.emailreply.value;
		query = query + "&from=" + escape(emailAddress);
	
	} else {
		// add callerID
		if (preferences.replies.value == 1) {
			//log('reply to mobile');
	
			var callerID = preferences.callerID.value;
			
			if (callerID.charAt(0) != '+') {
				setStatusText('Please specify your caller ID in \'international format\'.');
				return;
			}
			
			if (callerID.charAt(0) == '+' && callerID.length == 1) {
				setStatusText('Please specify your caller ID in \'international format\'.');
				return;
			}

			if (callerID.length > 0)
				query = query + "&from=" + escape(callerID);
		}
		
		// reply to email
		if (preferences.replies.value == 2) {
			//log('reply to email');
			query = query + "&reply=email"; 
			
			var emailAddress = preferences.emailreply.value;
			if (emailAddress.length > 0)
				query = query + "&from=" + escape(emailAddress);
		}
		
		// reply to none
		if (preferences.replies.value == 0 && preferences.usealphaID.value == 1) {
			//log('reply to none');
			
			var alphaID = preferences.alphaID.value;
			if (alphaID.length > 0)
				query = query + "&from=" + escape(alphaID);
		}
	
		// reports
		
		// add delivery
		var delivery = preferences.delivery.value;
		if (delivery != null && delivery == 1)
			query = query + "&deliv_ack=1";
			
		// add copy SMS
		var cc = preferences.cc.value;
		if (cc != null && cc == 1)
			query = query + "&cc=1";

		// add report email address
		if (delivery || cc) {
			var reportemail = preferences.reportEmailAddress.value;
			
			// use account ID when not defined
			if (reportemail == null || reportemail.length == 0 || !isEmail(reportemail)) {
				reportemail = email;
			} else {
				reportemail = escape(reportemail);
			}

			// add delivery email address
			query = query + "&contact=" + reportemail;
		}
	}
	
	// support concat
	var concat = calculateNumberOfSMS(unicode, len);
	if (concat > 1)
		query = query + "&concat=" + concat;

	// support Unicode
	if (unicode)
		query = query + "&unicode=1";
	
	log(query);
	
	// animation
	doTheWalk();
	
	//var url = new URL();
	//url.location = query;
	//url.fetchAsync(url_done);

	//var filename = system.userDocumentsFolder + "/xml.txt";
	//var xml = filesystem.readFile(filename);

	//doc = XMLDOM.parse(xml);
	//print(doc.toXML());

    req = new XMLHttpRequest();
    req.onreadystatechange = processReqChangeXML;
    req.open("GET", query, true);
   	req.send(null);

	setStatusText("Sending the SMS to: " + mobile + "...");

	return;
}

function processReqChangeXML() {

    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		WalkStop();

		// only if "OK"
        if (req.status == 200) {
        	print(req.responseXML.toXML());
            handleXMLResponse(req.responseXML); // print(req.responseXML.toXML());
         } else {
         	log("req.status = " + req.status + " != 200");
            doErrorMessage('1000');
         }
    }
}

function processReqChange() {

    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		WalkStop();

		// only if "OK"
        if (req.status == 200) {
            log(req.responseText);
            handleResponse(req.responseText);
         } else {
         	log("req.status != 200");
            doErrorMessage("1000");
         }
    }
}

function url_done(url) {

	log("fetch complete");	 

	// stop animation
	WalkStop();
	
	// only if "OK"
	if (url.response == 200) {
		log(url.result);
		handleResponse(url.result);
	 } else {
		log("req.status != 200");
		doErrorMessage("1000");
	 }
}

function handleXMLResponse(xml)
{
    var days = "?";
    var balance = "?";
    var message = "";
    var alertmsg = "";
    var keyName = "";
    var dataValue = "";
    var recipients = "0";
    var errorNumber = "0";
    var success = false;
    
    var softwareVersion = "";
    var softwareUpdate = false;
    
    var root = xml.documentElement;
    var nodeList = root.getElementsByTagName("key");
	if (nodeList.length <= 0) {
		log("No valid response from query");
		doErrorMessage('1000');
		return;
	} else {
		// initialize global variables 
		errorMessage = "";
		productURL = "";
		purchaseURL = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=purchase";
		trialAccount = false;
	}
	
	// find all keys	
	for (i=0;i<nodeList.length;i++) {
		node = nodeList.item(i);
	
		keyName = node.firstChild.data;
		dataValue = node.nextSibling.firstChild.data;
		
		//keyName = keys[i].firstChild.nodeValue;
		//dataValue = keys[i].nextSibling.nextSibling.firstChild.data;
		
		log(keyName);
		log(dataValue);
		
		switch(keyName) {
			case "Error":
				success = false;
				errorNumber = dataValue;
				break;
				
			case "ErrorMessage":
				errorMessage = dataValue;
				break;
				
			case "ID":
				success = true;
				break;
				
			case "Balance":
				balance = dataValue;
				smsbalance = balance;
				break;
				
			case "Recipients":
				recipients = dataValue;
				break;
				
			case "Expiration":
				days = dataValue;
				break;
				
			case "ProductVersion":
				softwareVersion = dataValue;
				softwareUpdate = true;
				break;
				
			case "ProductURL":
				productURL = dataValue; // global variable
				break;
				
			case "PurchaseURL":
				purchaseURL = dataValue; // global variable
				break;
				
			case "Trial":
				trialAccount = true;
				break;
				
			default:
				break;
		} // of switch
	} // of for loop
	
	
	// an error occurred
	if (!success) {
		doErrorMessage(errorNumber);
		return;
	}
	
	// expiration is near
	if (days != "?" && days <= 21 && trialAccount == false) {
	
		expired = true;
		
		// insert the number of days left
		if (days == 0) {
			message = "The SMS has been sent.";
			alertmsg = "Your Send SMS subscription will expire today. Please renew your subscription.";
		} else {
			message = "The SMS has been sent.";
			alertmsg = "Your Send SMS subscription will expire in %d days. Please renew your subscription.";
			alertmsg = alertmsg.replace(/%d/i, days);
		}
		
		// remember the fact
		preferences.hasAccount.value = 1;
		savePreferences();
				
	} else if (email2SMS) {
	
		message = "The SMS has been sent via email to the email2SMS gateway. This SMS has no cost.";
	
	// show balance
	} else if (balance != "?") {
	
		// insert the number of SMS left
		if (recipients != "0" && recipients != "1") {
		
			// we do not support groups yet
			message = "Number of SMS sent: %n. You still have %d SMS left in your balance.";// group
			message = message.replace(/%n/i, recipients);
			message = message.replace(/%d/i, balance);

		} else {
		
			// insert the number of SMS left
			message = "The SMS has been sent. You still have %d SMS left in your balance.";
			message = message.replace(/%d/i, balance);
			
		}
		
		// buy more SMS
		var number = Number(balance);
		if (number < 10) {
		
			buySMS = true;
			
			// buy more SMS
			alertmsg = "You still have %d SMS left in your balance. Please purchase the bundle of 100, 500 or 1000 SMS to increase your balance.";
			alertmsg = alertmsg.replace(/%d/i, balance);
			
			// trial SMS
			if (trialAccount) {
			
				if (number == 0) {
					alertmsg = "The SMS has been sent. There are no more trial SMS left. To order Send SMS, please click the Purchase button.";
				} else {
					alertmsg = "The SMS has been sent. You still have %d trial SMS left. To order Send SMS, please click the Purchase button.";
					alertmsg = alertmsg.replace(/%d/i, balance);
				}
				
				buySMS = false;
			}
			
		} else if (softwareUpdate) {
					
			// software update
			alertmsg = "A new version (%s) of Send SMS is available. Please update your software.";
			alertmsg = alertmsg.replace(/%s/i, softwareVersion);
			
		}
		
		// remember the fact
		preferences.hasAccount.value = 1;
		savePreferences();
	}
	
	// not in this case
	if (trialAccount) {
		preferences.hasAccount.value = 0;
		savePreferences();
	}

	// show the SMS balance
	setStatusText2(message);
	
	// update SMS Balance in preference pane
	if (smsbalance != null) {
		setBalance(smsbalance);
	}
	
	// show alerts
	
	if (trialAccount) {
	
		handleTrialCampaign(alertmsg);
		
	} else if (expired) {
		
		handleRenewCampaign(alertmsg);
		
	} else if (buySMS) {
	
		handleBuySMSCampaign(alertmsg);		
		
	} else if (softwareUpdate) {
	
		// software update
		var answer = alert(alertmsg, 'Software Update', 'Cancel');
		if (answer == 1) {
			openURL(productURL);
		}
		softwareUpdate = false;
		
	}
}

function handleResponse(txt)
{
	var line = "";
	
	if (txt.length == 0) {
		doErrorMessage("1000");
		return;
	} else {
		line = txt;
	}
	
	var lines = txt.split("\n");
	if (lines.length > 0) {
		line = lines[0];
	
		// NSRange range = [line1 rangeOfString:@"Software error"];
		
		txt = line.split(" ");
		
		if (txt.length > 1) {
			
			if (txt[0] == "ERR:") {
				if (txt[1] != null)
					doErrorMessage(txt[1]);
				else
					setStatusText2(line);
			} else if (txt[0] == "ID:") {
				var message;
				var n = "?";
				var days = "?";
				
				// get the second line
				if (lines.length > 1) {
					line = lines[1];
					txt = line.split(' ');

					// should contain number of SMS left
					if (txt.length > 1 && txt[0] == "BAL:") {
						n = txt[1];
					}
				}
								
				// get the third line
				if (lines.length > 2) {
					line = lines[2];
					txt = line.split(' ');

					// should contain number of days left
					if (txt.length > 1 && txt[0] == "EXP:") {
						days = txt[1];
					}
				}

				// show feedback
				if (days != "?" && days <= 21) {
				
					expired = true;
					
					// insert the number of days left
					message = "SMS sent. Your Send SMS subscription will expire in %d days. Please renew your subscription. Click on the middle button below."
					message = message.replace(/%d/, days);
				} else if (email2SMS) {
				
					message = "The SMS has been sent via email to the email2SMS gateway. This SMS has no cost.";
					
				} else {
					// insert the number of SMS left
					message = "SMS sent. You still have %d SMS left in your balance.";
					message = message.replace(/\%d/, n);
				
					// buy more SMS
					if (n != "?") {
						var number = Number(n);
						if (number < 10) {
							message = message + " " + "Please purchase the bundle of 100 SMS or 500 SMS to increase your balance.";
						}
					}
				}
				
				// show the SMS balance
				setStatusText2(message);
				
				// remember the fact
				preferences.hasAccount.value = 1;
				savePreferences();
				
			} else {
				setStatusText2("Unknown response.");
			}
			
		} else {
			// display this line
			setStatusText2(line);
		}
		
	} else {
		// display this line
		setStatusText2(line);
	} 
	
	return;
}

function setStatusText(txt)
{
	status = true;
	textSMS = text.data;

	text.data = txt;
	return;
}

function setStatusText2(txt)
{
	text.data = txt;
}

function cleartext()
{
	expired = false;
	
	if (status) {
		status = false;
		text.data = textSMS;
		
		textSMS = "";
	} else {
		text.data = "";
		unicodeLabel.data = "";
		setTotal(signatureLen);
	}
	
	WalkStop();
}

function doTheWalk()
{
	//walkerImg.hOffset = 30;
	//walkerImg.vOffset = 100;
	
	// make envelope visible
	letter.hOffset = 30;
	letter.visible = true;
	
	walkerObj = new MoveAnimation(letter, 135, 100, 1500, animator.kEaseNone, WalkDone); 
	animator.start(walkerObj); 
}

function WalkDone()
{
	log("walking"); 
	
	if (walkerObj != 0) {
		delete walkerObj;
		walkerObj = 0;
		
		letter.hOffset = 30;
		walkerObj = new MoveAnimation(letter, 135, 100, 1500, animator.kEaseNone, WalkDone); 
		animator.start(walkerObj); 
	}
}

function WalkStop()
{
	// stop animation
	if (walkerObj != 0) {
		walkerObj.kill();
		delete walkerObj;
		walkerObj = 0;
		
		// place it offscreen
		// walkerImg.hOffset = -100;
		
		// hide it again
		letter.hOffset = 30;
		letter.visible = false;
	}
}

function doErrorMessage(error)
{
	var alertmsg;
	
	switch(error) {
		case '105':
			setStatusText2("The mobile phone number was not accepted.");
			break;
		
		case '106':
			setStatusText2("The caller ID you specified in the preferences was not accepted.");
			break;
		
		case '1000':
			setStatusText2("No response. Perhaps there is a problem with your Internet connection.");
			break;
			
		case '1001':
			setStatusText2("Authentication failed. Please check your account ID and PIN in the account settings. To get an account, you will first need to subscribe to the Send SMS service.");
			break;
			
		case '1002':
			if (trialAccount) {
				setStatusText2("There are no more trial SMS left.");
				alertmsg = "There are no more trial SMS left. To order Send SMS, please click the Buy button.";
				handleTrialCampaign(alertmsg);
			} else {
				alertmsg = "Your SMS balance is zero. Please purchase the bundle of 100, 500 or 1000 SMS to increase your balance.";
				setStatusText2(alertmsg);
				handleBuySMSCampaign(alertmsg);
			}
			break;
			
		case '1003':
			setStatusText2("Three wrong entries. Since more than three times in succession the authentication failed, your account is now blocked. Please contact: support@smsmac.com.");
			break;
			
		case '1004':
			setStatusText2("An error occurred in a database operation. Please contact support at: support@smsmac.com.");
			break;
			
		case '1011':
			setStatusText2("A connection could not be established with the accounting database. Perhaps the web site is under maintenance.");
			break;
			
		case '1018':
			if (trialAccount) {
				alertmsg = "Your trial period has expired. To purchase the Send SMS software, please click the Buy button.";
				setStatusText2(alertmsg);
				handleTrialCampaign(alertmsg);
			} else {
				alertmsg = "Your SMS Mac or SMS Vista subscription has expired. Please renew your SMS Mac or SMS Vista subscription.";
				setStatusText2(alertmsg);
				handleRenewCampaign(alertmsg);
			}
			break;
			
		case '1025':
			setStatusText2("The SMS gateway could not be reached. This should be a temporary problem. Please try again later.");
			break;
			
		case '5000':
			setStatusText2("The Perl script crashed. Please send an email immediately to: support@smsmac.com.");
			break;
			
		case '6001':
			setStatusText2("This SMS can\'t be sent, because the following SMS feature is not supported for this destination: " + "Unicode.");
			break;
			
		case '6002':
			setStatusText2("This SMS can\'t be sent, because the following SMS feature is not supported for this destination: " + "Long SMS.");
			break;
			
		case '6004':
			setStatusText2("This SMS can\'t be sent, because the following SMS feature is not supported for this destination: " + "Flash.");
			break;
			
		case '6008':
			setStatusText2("The Reply to Email option is not supported for this destination. Please change this preference in the Replies preferences pane.");
			break;
			
		default:
			var msg = "An error occurred. Error: " + error;
			setStatusText2(msg);
			break;
	}
}

function alertText(msg) {
	alert(msg, 'OK');
}

function setTitle(title, number) {
	if (title.length > 0) {
		head.data = title.toUpperCase().substring(0,16);
		head.tooltip = "The mobile number of " + title + " is: " + number + ".";
	} else { 
		head.data = "CLICK HERE";
		head.tooltip = "Click here to enter the name and mobile number of the recipient.";
	}
}

function setTotal(n)
{
	total.data = "#: " + n;
}

function getSignature() {
	
	var signaturetxt = preferences.signature.value;
	var addsignature = preferences.addsignature.value;
		
	if (addsignature == 1) {
		if (signaturetxt != null && signaturetxt.length > 0) {
			// insert a carriage return
			signaturetxt = String.fromCharCode(10) + signaturetxt;
			return signaturetxt;
		}
	} 
		
	return null;
}

function getSignatureLen(txt) {
	var len = 0;
	var unicode = false;
	
	// get signature preference
	if (preferences.addsignature.value == 0) {
		return 0;
	}
	
	// determine SMS format
	if (isUnicode(txt)) {
		unicode = true;
	}

	if (unicode)
		len = txt.length;
	else
		len = gsmLength(txt);

	//log("Signature: " + txt);
	//log("Signature length is: " + len);

	return len;
}

function updateSignature() {
	// recalculate signature length
	
	// get signature
	var signature = getSignature();
	if (signature != null) {
		signatureLen = getSignatureLen(signature);
	} else {
		signatureLen = 0;
	}
	
	return signatureLen;
}

function EditHead() {
	if (preferences.name.value == "") {
		AddMobile();
	} else {
		var mobile = preferences.to.value;
		if (isEmail(mobile))
			EditEMobile();
		else
			EditMobile();
	}
}

function EditEMobile() {
	var name = preferences.name.value;
	var mobile = preferences.to.value;
	var index = findMobileIndex(preferences.to.value);
	EditEMobileWithParam(index, name, mobile);
}

function EditEMobileWithParam(myPlace, name, mobile) {
	var index = mobile.indexOf('@');
	var gate = mobile.substring(index);
	var mobileno = mobile.substring(0, index);
	
	var	formfields = Array(); 	
	formfields[0]	=	new	FormField() 
	formfields[0].name	=	'mobile';	 
	formfields[0].type	=	'text';	 
	formfields[0].title	=	"Mobile Number:";	 
	formfields[0].defaultValue	=	mobileno;	 
	formfields[0].description	=	"Edit the 10-digit mobile number of the recipient here. The number must belong to a mobile network in the USA. Do not add the +1 country code.";

	formfields[1] = new FormField();
	formfields[1].name = 'carrier';
	formfields[1].type = 'popup';
	formfields[1].title = 'Mobile Network:';
	formfields[1].description = "Select the mobile network.";
	formfields[1].option = CarrierList();
	formfields[1].optionValue = CarrierGateways();
	formfields[1].value = gate;
	
	formfields[2]	=	new	FormField();	 
	formfields[2].name	=	'name';	 
	formfields[2].type	=	'text';	 
	formfields[2].title	=	"Display Name:"; 
	formfields[2].defaultValue	=	name;	 
	formfields[2].description =  "Edit the name of the recipient here.";

	// show dialog
	formResults	= form(formfields, 'Edit eMobile Address', 'Modify', 'Cancel');

	// handle results
	if	(formResults !=	null)	{
		var emobile;
		var mobileno = formResults[0];
		var displayName = formResults[2];
		
		// check length
		if (mobileno.length != 10) {
			var answer = alert("The mobile number should contain 10 digits.", 'OK');
			return;
		}
		
		// strip all formatting
		mobileno = mobileno.replace(/[^0-9+]/g, "");

		// construct emobile address
		var gateway = formResults[1];
		if (gateway == "@mmode.com")
			emobile = "1" + mobileno + gateway;
		else
			emobile = mobileno + gateway;
			
		print(emobile);
		
		// add to recent mobiles list
		var updated = updateRecentMobile(displayName, emobile, myPlace);
		if (!updated) {
			alert("This mobile number or display name already exists in the Recent Mobiles list.", "OK");
			return;
		}
		
		// construct mobile number
		preferences.to.value = emobile;
		
		// get display name
		preferences.name.value = displayName;
		
		// save preferences
		savePreferences();
		
		// update mobile title
		setTitle(displayName, emobile);				
	}
}

function EditMobileWindow(index, name, number) {
	var	formfields = Array();
	
	formfields[0]	=	new	FormField() 
	formfields[0].name	=	'mobile';	 
	formfields[0].type	=	'text';	 
	formfields[0].title	=	"Mobile Number:";	 
	formfields[0].defaultValue	=	number;	 
	formfields[0].description	=	"Edit the mobile number of the recipient here. The mobile number must specified in international format.";
	formfields[0].description = formfields[0].description + " It should start with +1 (USA), +44 (UK), +49 (Germany), +33 (France). Etc.";
	
	formfields[1]	=	new	FormField();	 
	formfields[1].name	=	'name';	 
	formfields[1].type	=	'text';	 
	formfields[1].title	=	"Display Name:"; 
	formfields[1].defaultValue	=	name;	 
	formfields[1].description =  "Edit the name of the recipient here.";
	
	// show dialog
	formResults	= form(formfields, 'Edit Mobile Number', 'OK', 'Cancel');
	
	// handle form results
	if	(formResults !=	null)	{			
		var mobile = formResults[0];
		var displayName = formResults[1];

		// check international format
		if (mobile.charAt(0) != '+') {
			var answer = alert("The mobile number should be in \'international format\'. Press the Help button to read about \'international format\'.", 'OK', 'Help');
			if (answer == 2)
				openURL("http://www.smsmac.com/cgi-bin/hb?lang=en&subj=help");	
			return;
		}
		
		// strip all formatting
		mobile = mobile.replace(/[^0-9+]/g, "");
		
		// update recent mobiles list
		var updated = updateRecentMobile(displayName, mobile, index);
		if (!updated) {
			alert("This mobile number already exists in the Recent Mobiles list.", "OK");
			return null;
		}
		
		return formResults;
	}
}

function EditMobile() {
	if (preferences.name.value == "") {
		AddMobile();
	} else {
		var myPlace = findMobileIndex(preferences.to.value);
				
		// show window
		formResults	= EditMobileWindow(myPlace, preferences.name.value, preferences.to.value);
			
		// handle form results
		if	(formResults !=	null)	{			
			var mobile = formResults[0];
			var displayName = formResults[1];

			// construct mobile number
			preferences.to.value = mobile;
			
			// get display name
			preferences.name.value = displayName;
						
			// save preferences
			savePreferences();

			// update mobile title
			setTitle(displayName, mobile);
		}
	}
}

function AddEMobile() {
	var	formfields = Array(); 	
	formfields[0]	=	new	FormField() 
	formfields[0].name	=	'mobile';	 
	formfields[0].type	=	'text';	 
	formfields[0].title	=	"Mobile Number:";	 
	formfields[0].defaultValue	=	'';	 
	formfields[0].description	=	"Enter the 10-digit mobile number of the recipient here. The mobile number must belong to a mobile network in the USA. Do not add the +1 country code.";

	formfields[1] = new FormField();
	formfields[1].name = 'carrier';
	formfields[1].type = 'popup';
	formfields[1].title = 'Mobile Network:';
	formfields[1].description = "Select the mobile network.";
	formfields[1].option = CarrierList();
	formfields[1].optionValue = CarrierGateways();
	formfields[1].value = carriers[0].gate;
	
	formfields[2]	=	new	FormField();	 
	formfields[2].name	=	'name';	 
	formfields[2].type	=	'text';	 
	formfields[2].title	=	"Display Name:"; 
	formfields[2].description =  "Enter the name of the recipient here.\n\nSMS to eMobile addresses have no cost and are sent by email.";

	// show dialog
	formResults	= form(formfields, 'Add eMobile Address', 'Add', 'Cancel');

	// handle results
	if	(formResults !=	null)	{
		var emobile;
		var mobileno = formResults[0];
		var displayName = formResults[2];
		
		if (mobileno.length != 10) {
			var answer = alert("The mobile number should contain 10 digits.", 'OK');
			return;
		}
		
		// strip all formatting
		mobileno = mobileno.replace(/[^0-9+]/g, "");

		// construct emobile address
		var gateway = formResults[1];
		if (gateway == "@mmode.com")
			emobile = "1" + mobileno + gateway;
		else
			emobile = mobileno + gateway;
			
		print(emobile);
		
		// add to recent mobiles list
		var added = addRecentMobile(displayName, emobile);
		if (!added) {
			alert("This mobile number or display name already exists in the Recent Mobiles list.", "OK");
			return;
		}
		
		// construct mobile number
		preferences.to.value = emobile;
		
		// get display name
		preferences.name.value = displayName;
		
		// save preferences
		savePreferences();
		
		// update mobile title
		setTitle(displayName, emobile);				
	}
}

function AddMobile() {
	var	formfields = Array(); 	
	formfields[0]	=	new	FormField() 
	formfields[0].name	=	'mobile';	 
	formfields[0].type	=	'text';	 
	formfields[0].title	=	"Mobile Number:";	 
	formfields[0].defaultValue	=	'+1';	 
	formfields[0].description	=	"Enter the mobile number of the recipient here. The mobile number must specified in so-called \'international format\'.";
	formfields[0].description = formfields[0].description + " It should start with the country code: +1 (USA), +44 (UK), +49 (Germany), +33 (France), etc. After the country code you should enter the mobile number. The leading zero of the mobile number, if any, should be omitted.";

	formfields[1]	=	new	FormField();	 
	formfields[1].name	=	'name';	 
	formfields[1].type	=	'text';	 
	formfields[1].title	=	"Display Name:"; 
	formfields[1].description =  "Enter the name of the recipient here.";
	
	// show dialog
	formResults	= form(formfields, 'Add Mobile Number', 'Add', 'Cancel');
	
	// handle results
	if	(formResults !=	null)	{	 
		var mobile = formResults[0];
		var displayName = formResults[1];
		
		if (mobile.charAt(0) != '+') {
			var answer = alert("The mobile number should be in \'international format\'. Press the Help button to read about \'international format\'.", 'OK', 'Help');
			if (answer == 2)
				openURL("http://www.smsmac.com/cgi-bin/hb?lang=en&subj=help");	
			return;
		}
		
		// log to the debug window
		// log(displayName);
		// log(mobile);

		// strip all formatting
		mobile = mobile.replace(/[^0-9+]/g, "");
		// log(mobile);

		// add to recent mobiles list
		var added = addRecentMobile(displayName, mobile);
		if (!added) {
			alert("This mobile number or display name already exists in the Recent Mobiles list.", "OK");
			return;
		}
		
		// construct mobile number
		preferences.to.value = mobile;
		
		// get display name
		preferences.name.value = displayName;
		
		// save preferences
		savePreferences();
		
		// update mobile title
		setTitle(displayName, mobile);				
	}
}

function RemoveRecentMobile() {
	print("remove mobile");
	var	formfields = new Array(); 
  
	formfields[0] = new FormField();
	formfields[0].name = 'mobile';
	formfields[0].type = 'popup';
	formfields[0].title = 'Mobile:';
	formfields[0].description = "Select the contact you want to remove from the Recent Mobiles list.";
	formfields[0].option = RecentNamesList();
	formfields[0].optionValue = IndexesMobiles();
	formfields[0].value = 0;

	formResults	= form(formfields, 'Remove Recent Mobile', 'Remove', 'Cancel'); 
	if (formResults != null) {
    	removeRecentMobileByIndex(formResults[0]);
	} 
}

function EditRecentMobile() { // must handle case here for eMobile!
	print("edit mobile");
	var	formfields = new Array(); 
  
	formfields[0] = new FormField();
	formfields[0].name = 'mobile';
	formfields[0].type = 'popup';
	formfields[0].title = 'Mobile:';
	formfields[0].description = "Select the contact you want to edit from the Recent Mobiles list.";
	formfields[0].option = RecentNamesList();
	formfields[0].optionValue = IndexesMobiles();
	formfields[0].value = 0;

	formResults	= form(formfields, 'Edit Recent Mobile', 'Edit', 'Cancel'); 
	if (formResults != null) {
    	editRecentMobileByIndex(formResults[0]);
	} 
}

function ImportYahoo() {
	print("import Yahoo!");

	//yahooLogout();
	//return;
	
	if (yahooCheckLogin())
		getYahooAddressBookQ();
	else {
		print("not logged in");
		answer = alert("Please sign in to Yahoo! to access your Yahoo! Address Book.", "OK", "Cancel");
		if (answer == 1)
			yahooLogin();
	}
}

function doChars() 
{
	var unicode = false;
	var previousValue = false;

	var txt = text.data;
	var n = txt.length;
			
	// ignore dead keys
	var value = txt.charCodeAt([n-1]);	
	if (value == 96 || value == 94 || value == 168 || value == 176 || value == 180 || value == 710 || value == 732) {
		log("dead key");
		txt = txt.substring(0, n-1);
	}
	
	if (unicodeLabel.data == "Unicode")
		previousValue = true;
		
	// determine SMS format
	if (isUnicode(txt)) {
		unicode = true;
		log("Unicode SMS");
	}
		
	// Unicode alert
	if (preferences.unicodeAlert.value == 1 && previousValue == false && unicode == true) {
		var answer = alert("The last character you typed made this a Unicode SMS and now can contain only 70 characters. A normal SMS can contain 160 characters. Do you wish to continue and create a Unicode SMS?", "Yes", "No", "Don\'t show again");
		if (answer == 2) {
			// delete the last (Unicode) character
			txt = txt.substring(0, n-1);
			text.data = txt;
			unicode = false;
			n = n - 1;
		} else if (answer == 3) {
			// don't show alert again
			preferences.unicodeAlert.value = 0;
			savePreferences();
		}
	}
	
	// label Unicode
	if (unicode)
		unicodeLabel.data = "Unicode";
	else
		unicodeLabel.data = "";
		
	// get signature length
	var signature = getSignature();
	if (signature != null) {
		signatureLen = getSignatureLen(signature);
	} else {
		signatureLen = 0;
	}	
	
	// show number of characters	
	n = n + signatureLen;
	setTotal(n);
	
	// show number of SMS, i.e. [2] in case of Unicode SMS
	var nSMS = calculateNumberOfSMS(unicode, n);
	if (nSMS > 1) {
		total.data = total.data + " [" + nSMS + " SMS]";
	}
}

function calculateNumberOfSMS(unicode, nChars) {
    var nSMS = 0;
    
    var len = lengthOfOneSMS(unicode)
    
    if (nChars <= len)
        nSMS = 1;
    else {
        // 7 octets = 7 * 8 = 56 bits, 56 bits / 7 bits = 8 characters in the GSM 7bit character set
        if (unicode)
            len = 70 - 7;
        else
            len = 160 - 7; // with testing it seems 153 can be contained
            
        nSMS = Math.floor(nChars / len );
        
        if ((nChars % len) != 0)
            nSMS += 1;
    }
        
    return nSMS;
}

function lengthOfOneSMS(unicode) {
    var len = 0;
    
    if (unicode)
        len = 70;
    else
        len = 160;
        
    return len;
}

function updtfontcolor(userColor)
{
	var elem = head;
	
	switch(userColor) {
		case 'Red':
		case 'Blue':
		case 'Green':
		case 'Orange':
			elem.color= '#000000';// black
			break;
			
		default:
			elem.color= '#FFFFFF';// white
			break;
	}
	
	elem = total;
	
	switch(userColor) {
		case 'Red':
		case 'Blue':
		case 'Green':
		case 'Orange':
			elem.color='#666666';
			break;
			
		case 'White':
			elem.color='#FFFFFF';
			break;
			
		default:
			elem.color= '#999999';
			break;
	}
	
	elem = unicodeLabel;
	
	switch(userColor) {
		case 'Red':
		case 'Blue':
		case 'Green':
		case 'Orange':
			elem.color='#666666';
			break;
			
		case 'White':
			elem.color='#FFFFFF';
			break;
			
		default:
			elem.color= '#999999';
			break;
	}
	
}

function updtWidgetColor(color)
{
	log('updtWidgetColor');
	
	switch(color) {
		case 'Grey':
			front.src = "Resources/grey.png";
			break;
			
		case 'Red':
			front.src = "Resources/red.png";
			break;
			
		case 'Green':
			front.src = "Resources/green.png";
			break;
			
		case 'Blue':
			front.src = "Resources/blue.png";
			break;
			
		case 'Orange':
			front.src = "Resources/orange.png";
			break;
			
		case 'White':
			front.src = "Resources/white.png";
			break;
			
		default:
			front.src = "Resources/front.png";
			break;
	}
	
	updtfontcolor(color);
}

function CarrierList() {
	var names = new Array();
    
	for (var i = 0; i < carriers.length; i++) {
		names[i] = carriers[i].name;
	}
  
	return names;
}

function CarrierGateways() {
	var gates = new Array();
    
	for (var i = 0; i < carriers.length; i++) {
		gates[i] = carriers[i].gate;
	}
  
  return gates;
}

function isEmail(emailAddress) {
	var flag = false;
  
	if (emailAddress && emailAddress.match(/^(.+)@(.+)\.(.+)$/)) {
		flag = true;
	}
  
	return flag;
}

function getYahooAddressBookQ() {
	answer = alert("Do you want to import the mobile numbers of the Yahoo! Address Book?", "Yes", "No");
	if (answer == 1)
		getYahooAddressBook();
}

function getYahooAddressBook()
{
	var searchPhrase = "";

	url = new URL();
	addressBookXML = url.fetch("http://address.yahoo.com?v=XM&prog=Konfabulator&tags=long&search-type=and&s=" + escape(searchPhrase));	

	x = XMLDOM.parse( addressBookXML );
	people = x.getElementsByName( "contact" );

	if (people.length == 0)
		return;
	else
		yahooArray = new Array();
		
	for (var i = 0; i < people.length; i++)
	{
		mobileno = people.item(i).getAttribute( "mobile" );
		if (mobileno == null || mobileno == "") 
			continue;
		
		ln = people.item(i).getAttribute( "last-name" );
		mn = people.item(i).getAttribute( "middle-name" );
		fn = people.item(i).getAttribute( "first-name" );
		
		if (mn != null && mn != "")
			name = fn + " " + mn + " " + ln;
		else
			name = fn + " " + ln;
	
		addYahooMobile(name, mobileno);
	}
	
	writeYahooAddressBook();
}

function escapePath(path)
{
	return path.replace(/([\W])/g,'\\$1'); 
}

function ImportOutlook()
{
	// authors: Rene Laterveer and Alco Blom
	log("ImportOutlook");
	var result = runCommand(convertPathToPlatform("./bin/importOutlook"));
	var prefString = unescape(result);

	//log("the preferences string is: " + prefString);
	
	preferences.outlookContacts.value = prefString;
	savePreferences();
	
	var tmpString = prefString.replace("\'","'");
	try {
		var tmpArray = new Array();
		tmpArray = eval( "new Array(" + tmpString + ")" );
		log("Imported " + tmpArray.length + " contacts");
		delete tmpArray;
	} catch(exception) {
		alert('A problem occurred importing the Outlook Contacts.');
		log(tmpString);
	}
	
	log("Outlook contacts imported");
}

function ImportAddressBook()
{
	// authors: Rene Laterveer and Alco Blom
	// perhaps use system.widgetDataFolder 

	log("ImportAddressBook");
	var result = runCommand(convertPathToPlatform("./bin/importAddressBook"));
	var prefString = unescape(result);

	//var extPath = widget.extractFile("./bin/importAddressBook");
	//log(extPath);
	//extPath = escapePath(extPath);
	//log(extPath);
	//extPath = escapePath(system.widgetDataFolder) + "/importAddressBook";
	//log(extPath);

	//log("the preferences string is: " + prefString);
	
	preferences.addressBookContacts.value = prefString;
	savePreferences();

	var tmpString = prefString.replace("\'","'");
	try {
		var tmpArray = new Array();
		tmpArray = eval( "new Array(" + tmpString + ")" );
		log("Imported " + tmpArray.length + " contacts");
		delete tmpArray;
	} catch(exception) {
		alert('A problem occurred importing the Address Book.');
		log(tmpString);
	}

	log("Address Book imported");
}

function setBalance(value)
{
	// to be implemented
}

function addCampaign(url, campaignName, addAccount) {
	var productCode;
		
	if ( system.platform == "macintosh" )
		productCode = "KFM" + productComputerVersion;
	else
		productCode = "KFW" + productComputerVersion;

	// Google Analytics Campaign
	url = url + "&utm_source=yahoowidgets&utm_medium=software&utm_content=" + productCode +"&utm_campaign=" + campaignName;
				
	if (addAccount) {
		var email = preferences.accountID.value;
		if (email != null && email.length != 0) {
			email = escape(email);
			url = url + "&account=" + email;
		}
	}
		
	return url;
}

function doRenewOpenURL() {
	var url = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=renew";
	url = addCampaign(url, 'renew', true);
	openURL(url);
}

function doBuySMSOpenURL() {
	var url = "http://www.smsmac.com/cgi-bin/hb?lang=en&subj=buysms";
	url = addCampaign(url, 'buysms', true);
	openURL(url);
}

function doPurchaseOpenURL(purchaseURL) {
	var url = addCampaign(purchaseURL, 'trialsms', true);
	openURL(url);
}

function handleTrialCampaign(msg) {
	// ask user to purchase
	var answer = alert(msg, 'Buy', 'Cancel');
	if (answer == 1) {
		doPurchaseOpenURL(purchaseURL);
	}
	trialAccount = false;
}

function handleBuySMSCampaign(msg) {
	// ask user to buy SMS
	var answer = alert(msg, 'Buy SMS', 'Cancel');
	if (answer == 1) {
		doBuySMSOpenURL();
	}
	buySMS = false;
}

function handleRenewCampaign(msg) {
	// ask user to renew
	var answer = alert(msg, 'Renew', 'Cancel');
	if (answer == 1) {
		doRenewOpenURL();
	}
	expired = false;
}

